
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <iostream.h>

class a 
{  public :
     a(int,double);
     a();
     ~a();
     void setName(char *);
     a operator =(const a&);
     friend ostream& operator <<(ostream&,const a&);


   private:
     int v1;
     double v2;
     char name[30];
};

a::a()
{  v1=0; v2 = 0;  sprintf(name,"%s","nothing");
   cout << " allocate a " << name << endl;
}

a::a(int av1, double av2)
{  v1=av1; v2 = av2; sprintf(name,"<%3d-%5.3f>",av1,av2);
   cout << " allocate a " << name << endl;
}

void a::setName(char *nName) { strncpy(name,nName,29); }

a::~a()
{ cout << " de allocate a " << name << endl;
}

a a::operator =(const a& RHS)
{  v1 = RHS.v1; 
   v2 = RHS.v2; 
   sprintf(name,"%s",RHS.name); 
   return (*this);
}

ostream& operator <<(ostream& os, const a&RHS)
{  os << "(" << RHS.v1 << "," << RHS.v2 << ") ";
   return os;
}

class b
{  public :
     b();
     b(const b&);
     void add(a);
     ~b();
     friend ostream& operator <<(ostream&,const b&);
     b operator =(const b&);
     void setName(char *);

   private:
     int index;
     a*  myList;
     char name[30];

};

b::b()
{  index = 0;
   myList = NULL;
   cout << " allocate b " << endl;
   sprintf(name,"nothing");
}

b::~b()
{  cout << " de allocate b before reclaim it " << name << endl;
   if(index) delete [] myList;
   //if(index) free(myList);
   cout << " de allocate b after reclaim it " << name << endl;
}

void b::add(a newE)
{  a* temp = new a[index+1];
   //if((temp=(a*)calloc(index+1,sizeof(a)))!=NULL)
   //{
   cout << " after allocate temp in b::add " << endl; 
   for(int i=0;i<index;i++) temp[i] = myList[i];
   temp[i] = newE;
   cout << " before reclaim the previous list " << endl;
   if(index) delete [] myList;
   //if(index) free(myList);
   cout << " reclaim the previous list " << endl;
   index++;
   myList = &(temp[0]);
   cout << " end of b::add " << endl;
   //}
}

void b::setName(char *newName) { strncpy(name,newName,30); }

b::b(const b& RHS)
{  
   cout << " in copy constructor " << endl;
   //if(index) delete [] myList;
   index = RHS.index;
   myList = new a[index];
   for(int i=0;i<index;i++) myList[i] = RHS.myList[i];
}// end of copy constructor

b b::operator=(const b&RHS)
{  
   cout << " in b::operator=( " << endl;
   if(index) delete [] myList;
   //if(index) free(myList);
   index = RHS.index;
   myList = new a[index];
   //if((myList=(a *)calloc(index,sizeof(a)))!=NULL) 
   //{
   for(int i=0;i<index;i++) myList[i] = RHS.myList[i];
   cout << " At the end of b::operator=( " << endl;
   //}

   return (*this);
}

ostream& operator<<(ostream& os, const b& RHS)
{  os << "There are " << RHS.index << " elements in the list " << endl;
   for(int i =0;i<RHS.index;i++) os << "List["<<i<<"]= "<<RHS.myList[i] << endl;
   return os;
}

class c
{  public:
     c();
     ~c();
     void addB(b);
     friend ostream& operator<<(ostream&,const c&);

   private :
     b* myList;
     int index;
};

c::c()
{  index = 0;
   myList = NULL;
}

c::~c()
{ if(index) delete [] myList;
  //if(index) free(myList);
  cout << " de allocate c" << endl;
}

void c::addB(b newE)
{  b* temp = new b[index+1];
   char aName[30];
 
   //if((temp=(b*)calloc(index+1,sizeof(b)))!=NULL)
   //{

   for(int i=0;i<index+1;i++) 
   {  sprintf(aName,"c::addB<%3d>",i);
      temp[i].setName(aName);
   }

   cout << " in c::addB " << endl;
   
   for(i=0;i<index;i++) temp[i] = myList[i];

   cout << "  in c::addB  after copy them " << endl;
   temp[i] = newE;
   if(index) delete [] myList;
   //if(index) free(myList);
   cout << "   after delete [] myList index:  " << index << endl;
   index++;
   myList = &(temp[0]);
   //myList = new b[index];
   //for(i=0;i<index;i++) myList[i]=temp[i];
   //delete [] temp;
   cout << "   after myList = temp " << endl;
   //}
}

ostream& operator<<(ostream& os, const c& RHS)
{  os << "There are " << RHS.index << " elements in the list " << endl;
   for(int i =0;i<RHS.index;i++) os << "List["<<i<<"]= "<<RHS.myList[i] << endl;
   return os;
}

main()
{ int i;
  c list;
  char aName[30];
  
  i=0;
  while(i<100)
  {  
     cout << " beginning of the outer loop " << endl;
     int m =0;
     b myb;
     sprintf(aName,"<%3d>",i);
     myb.setName(aName);

     while(m<5&&i<100)
     { a k(i,2.5*i);
       sprintf(aName,"<%3d-%5.3f>",i,2.5*i);
       k.setName(aName);
       cout << " before myb.add "  << endl;
       myb.add(k);
       cout << " after myb.add "  << endl;
       i++;
       m++;
       cout << " after m: " <<m << " i: "<< i << " addition " << myb << endl;
     }
     cout << " end of the inner looop " << endl;
     list.addB(myb);
     cout << " after " << i << " addition " << list << endl;
  }
}
